Added ability to deal with iso files given via the -n option
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ###############################################
41 # Command line processing
42 typeset dvdname=""
43 typeset debug=""
44 typeset dest=""
45 typeset isofile=""
46 typeset vobfile=""
47 typeset dvdpath=""
48 typeset aspect=""
49 typeset SCALE=""
50 typeset CROP=""
51 typeset -i keep_isofile=0
52 typeset -i keep_vobfile=0
53 typeset -i keep_dvdfolder=0
54 typeset -i keep_intermediate_files=0
55 typeset -i make_final_dest_vob=0
56 typeset -i make_final_dest_iso=0
57 typeset -i make_final_dest_folder=0
58 typeset -i make_final_dest_avi=0
59 typeset -i errors=0
60 typeset -i show_usage=0
61 typeset -i mirror_mode=0
62 typeset -i target_bitrate=0
63 typeset -i target_size=0
64 typeset -i audio_2ch=0
65 typeset -i invalid_feature_title=0
66 typeset -i feature_title_override=0
67 typeset -i mplayer_dumpstream_incompatibility=0
68
69 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a: opt "$@"
70 do
71     case $opt in
72         (n)     dvdname=$OPTARG;;
73         (d)     dest=$OPTARG;;
74         (b)     target_bitrate=$OPTARG;;
75         (s)     target_size=$OPTARG;;
76         (2)     audio_2ch=1;;
77         (v)     make_final_dest_vob=1;;
78         (i)     make_final_dest_iso=1;;
79         (f)     make_final_dest_folder=1;; 
80         (x)     make_final_dest_avi=1;;
81         (m)     mirror_mode=1;;
82         (k)     keep_intermediate_files=1;;
83         (t)     feature_title_override=$OPTARG;;
84         (a)     aspect=$OPTARG;;
85         (w)     set -$opt;;
86         (h)     show_usage=1;;
87         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
88         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
89     esac
90 done
91
92 shift $((OPTIND-1))
93
94 function usage() {
95     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
96     echo >&2 "Revision $REV"
97     echo >&2 "Options:"
98     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
99     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
100     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
101     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
102     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
103     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
104     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
105     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
106     echo >&2 "                 The default operation is non-mirror mode where only the main"
107     echo >&2 "                 feature title will be ripped."
108     echo >&2 "   -v            Make the final image a DVD VOB file"
109     echo >&2 "   -i            Make the final image a DVD ISO file"
110     echo >&2 "   -f            Make the final image a DVD folder"
111     echo >&2 "   -x            Make the final image an AVI (XVID) file"
112     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
113     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
114     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
115     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
116     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
117     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
118     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
119     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
120     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
121     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
122     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
123     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
124     echo >&2 ""
125     exit 2
126 }
127
128 if (($errors)) || (($show_usage))
129 then
130   usage
131 fi
132
133 # Sanity Check - Command Line Options 
134 if [ "$dest" == "" ]; then
135   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
136   usage
137 fi
138
139 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_avi -ne 1 ]; then
140   echo "-E- You can't specify a bitrate, target_size, or aspect in non AVI file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
141   usage
142 fi
143
144 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
145   echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
146   usage
147 fi
148
149 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
150    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
151   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
152   usage
153 fi
154
155 if [ $mirror_mode -eq 1 ]; then
156   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
157      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
158     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
159     usage
160   fi
161 fi
162
163 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
164 if [ "$aspect" != "" ]; then
165   echo "$aspect" | grep -q "x"
166   if [ $? == 0 ]; then
167     echo "-E- You must specify the aspect option with a value whose format is W:H"
168     exit 1
169   fi
170   echo "$aspect" | grep -q ":"
171   if [ $? != 0 ]; then
172     SCALE=",scale -zoom -xy $aspect"
173   else
174     SCALE=",scale=$aspect"
175   fi
176 fi
177
178
179 # Sanity Check - Key executables
180 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
181 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
182 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
183 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
184 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
185 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
186 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
187 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
188
189 ###############################################
190
191 typeset -i ripdvd
192 if [ -z "$dvdname" ]; then
193   # make sure the DVD device is accessible
194   volname $dev > /dev/null 2>&1
195   if [ $? != 0 ]; then
196     echo "-E- Can't access the DVD device $dev"
197     exit 1
198   fi
199   # now capture the volume name from the device
200   dvdname=`volname $dev | awk '{ print $1 }'`
201   ripdvd=1
202 else 
203   # check to see if dvdname is a full path to a real directory
204   # if it is, set dvdname and dvdpath appropriately
205   if [ -d "$dvdname" ]; then
206     dvdpath="$dvdname"
207     dvdname=`basename "$dvdname"`
208     keep_dvdfolder=1
209     if [ -z "$dvdname" ]; then
210      echo "-E- Unable to extract dvdname from path: $dvdpath"
211      exit 1
212     fi
213     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
214       echo "-E- You must supply a full path to a valid DVD folder with this option"
215       exit 1
216     fi
217   fi
218
219   # Check to see if dvdname is a full path to a file
220   if [ -f "$dvdname" ]; then
221     valid_file=0
222
223     # check to see if dvdname is a full path to an MPG2 (VOB) file
224     # if it is, set dvdname and vobfile appropriately
225     file "$dvdname" | grep -q "MPEG"
226     if [ $? == 0 ]; then
227       # It is a valid MPEG2 file, now strip the extension off our dvdname
228       vobfile="$dvdname"
229       dvdname=`basename "$dvdname"`
230       dvdname=${dvdname%.[^.]*}
231       keep_vobfile=1
232       valid_file=1
233     fi
234
235     # check to see if dvdname is a full path to an ISO file
236     # if it is, set dvdname and isofile appropriately
237     file "$dvdname" | grep -q "ISO"
238     if [ $? == 0 ]; then
239       # It is a valid ISO file, now strip the extension off our dvdname
240       isofile="$dvdname"
241       dvdname=`basename "$dvdname"`
242       dvdname=${dvdname%.[^.]*}
243       keep_isofile=1
244       valid_file=1
245     fi    
246
247     # If we didn't find a handler for the file above, complain
248     if [ $valid_file -eq 0 ]; then
249       echo "-E- Unsupported file type: $vobfile"
250       exit 1
251     fi
252   fi
253   ripdvd=0
254 fi
255
256 # remove bad characters from the dvdname
257 dvdname=${dvdname%.} # remove trailing '.' character
258
259 # make a "safe" dvdname (remove special characters)
260 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
261
262 # Make sure we have a non-empty dvdname
263 if [ -z "$dvdname" ]; then
264   echo "-E- unable to determine dvdname"
265   exit 1
266 fi
267
268 # make sure our vobfile value is set
269 if [ -z "$vobfile" ]; then
270   vobfile="$dest/$dvdname.VOB"
271 fi
272
273 # set up some variables to hold various logfiles
274 logfile="$logdir/$dvdname.log"
275 passlogfile="$tmpdir/$safedvdname.log"
276 ddrescuelog=`tempfile`
277 dvdauthorlog=`tempfile`
278 encodelog=`tempfile`
279 dumplog=`tempfile`
280
281 # create the tmpdir if it doesn't already exist
282 if [ ! -d "$tmpdir" ]; then
283   mkdir -p "$tmpdir"
284   if [ $? != 0 ]; then
285     echo "-E- Unable to create the tmpdir: $tmpdir"
286     exit 1
287   fi
288 fi
289
290 # create the logdir if it doesn't already exist
291 if [ ! -d "$logdir" ]; then
292   mkdir -p "$logdir"
293   if [ $? != 0 ]; then
294     echo "-E- Unable to create the logdir: $logdir"
295     exit 1
296   fi
297 fi
298
299 ###############################################
300 # cleanup functions
301 cleanup() { 
302   if [ $keep_intermediate_files -eq 0 ]; then
303     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
304     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
305     [[ -e "$encodelog" ]] && rm -f "$encodelog"
306     [[ -e "$dumplog" ]] && rm -f "$dumplog"
307   else
308     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
309     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
310     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
311     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
312   fi
313   echo ""
314 }
315
316 fatal_and_exit() {
317   if [[ -z "$1" ]]; then
318     msg="-E- control-c killed us"
319   else
320     msg=$1
321   fi
322   echo -e 2>&1 "$msg" | tee -a "$logfile"
323   if [[ -n "$mailto" ]]; then
324     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
325   fi
326   exit 1
327 }
328
329 # Call our cleanup functions on INT and EXIT signals
330 trap fatal_and_exit INT
331 trap cleanup EXIT
332
333 ###############################################
334 # processing functions
335 function make_dvd_iso_image {
336
337   isofile="$1"
338
339   # check to see if we have a dvdpath to rip from instead of $dev
340   if [ -z "$dvdpath" ]; then
341     # load the CSS codes in the DVD drive 
342     lsdvd $dev >> "$logfile"
343     if [ $? != 0 ]; then
344       fatal_and_exit "-E- lsdvd $dev failed" 
345     fi
346
347     # read the DVD, ignoring/skipping CRC errors
348     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
349     if [ $? != 0 ]; then
350       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
351     fi
352     cat "$ddrescuelog" >> "$logfile"
353   else
354     # rip from a path instead
355     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
356   fi
357 }
358
359 function make_dvd_iso_image_from_folder {
360   
361   src="$1"
362   dst="$2"
363   handle_error=$3
364   
365   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
366
367   # make an iso image out of our directory
368   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
369   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
370
371   # set the audio languages from the iso if it exists and is non-zero in size
372   if [ -s "$dst" ]; then
373     get_feature_title "$dst"
374     get_audio_id_from_iso "$dst"
375   fi
376
377   # make sure we were able to create the iso image from the folder given to us
378   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
379     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
380     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
381     # remove the bad iso file
382     [[ -e "$dst" ]] && rm -f "$dst"
383     # get the feature title from the DVD folder
384     get_feature_title "$dvdpath"
385     # create our main VOB file from the ISO
386     create_main_vob_with_mplayer "$dvdpath" 
387     # get our audio id from the VOB file
388     get_audio_id_from_vob "$vobfile"
389   fi
390 }
391
392 function make_dvdbackup_folder_image {
393   # extract the feature title from the DVD image
394   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
395   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
396   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
397   if [ $? != 0 ]; then
398     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
399   fi
400 }
401
402 function make_dvdauthor_folder_image {
403   # create a new DVD video of the feature title
404   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
405   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
406   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
407   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
408
409   # There is a chance that dvdauthor won't like some of the VOBs.
410   # We can't tell ahead of time which ones it will choke on. 
411   # So, we need to run it over and over again until it can process
412   # all the VOBs. If it can't handle one of them, run it through
413   # mencoder to fix it and try again. These errors are typically
414   # present due to the copy protection that ddrescue removed.
415   grep -q "SCR moves" $dvdauthorlog
416   while [ $? == 0 ]; do
417     # fix bad vobs that get the "SCR moves backwards" error:
418     #  STAT: Processing VTS_01_0.VOB...
419     #  ERR:  SCR moves backwards, remultiplex input.
420     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
421     if [[ ! -f "$badvob" ]]; then
422       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
423     fi
424     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
425     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
426     mv -f $badvob.fixed $badvob
427     echo "-> Creating DVD video $dest/$dvdname"
428     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
429     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
430     grep -q "SCR moves" $dvdauthorlog
431   done
432 }
433
434 function get_feature_title {
435   source="$1"
436   # if a feature title was given on the command line, use it
437   if [ $feature_title_override -ne 0 ]; then
438     feature_title=$feature_title_override
439     return 0
440   fi
441   # otherwise, use lsdvd to figure it out
442   if [ $ripdvd -eq 1 ]; then
443     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
444   else 
445     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
446   fi
447 }
448
449 function create_main_vob_with_cat {
450   # cd to the feature title DVD folder
451   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
452   if [ $? != 0 ]; then
453     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
454   fi
455
456   # concatenate all the VOBs together into 1 giant VOB
457   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
458   cat $vobs > "$tmpdir/$dvdname.VOB"
459
460   # cd back to the dir we started from
461   popd > /dev/null 2>&1
462 }
463
464 function create_main_vob_with_mplayer {
465
466   # argument processing  
467   source="$1"
468   remove_dumplog=$2
469
470   # make sure we have a valid feature title
471   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
472     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
473   fi
474
475   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
476   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
477     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
478     msg="$msg We also detected another condition that requires us to use dumpstream. "
479     msg="$msg\n    Unable to rip this DVD in the mode you requested."
480     fatal_and_exit "$msg"
481   fi
482
483   # use mplayer to create the main VOB file
484   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
485   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
486   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
487   if [ $? != 0 ]; then
488     cat $dumplog | grep -v "^A:" >> "$logfile"
489     fatal_and_exit "-E- Mplayer Failed"
490   fi
491   cat $dumplog | grep -v "^A:" >> "$logfile"
492   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
493 }
494
495 function get_audio_id_from_iso {
496   # Adjust our audio ID to find the english audio stream
497   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
498   iso="$1"
499   aidcheck=`tempfile`
500   aid=128
501   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
502   grep -q "aid: $aid" $aidcheck
503   while [ $? == 1 ] && [ $aid -lt 159 ]; do
504     (( aid = aid + 1 ))
505     grep -q "aid: $aid" $aidcheck
506   done
507   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
508   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
509   # mencoder default DVD audio track language selection (english)
510   lang_opts="-aid $aid -alang en"
511 }
512
513 function get_crop_from_iso { 
514   FRAMES=10000
515   echo "-> Detecting black frame border crop value from ISO file"
516   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
517   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
518   [[ -e "md5sums" ]] && rm -f "md5sums"
519   CROP=`cat $dumplog | grep CROP | tail -1`
520   echo "   Found crop value of $CROP" >> "$logfile"
521   CROP=${CROP#* crop=}
522   CROP=${CROP%%\).*}
523   typeset -i CROPCHECK
524   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
525   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
526   if [ -z "$CROP" ]; then
527     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
528   fi
529   if [ $CROPCHECK -lt 0 ]; then 
530     CROP=""
531   else 
532     CROP=",crop=$CROP"
533   fi
534   echo "   Setting mencoder crop filter to: $CROP"
535 }
536
537 function get_audio_id_from_vob {
538   # Adjust our audio ID to find the english audio stream
539   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
540   vob="$1"
541   aidcheck=`tempfile`
542   aid=128
543   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
544   grep -q "Found audio stream: $aid" $aidcheck
545   while [ $? == 1 ] && [ $aid -lt 159 ]; do
546     (( aid = aid + 1 ))
547     grep -q "Found audio stream: $aid" $aidcheck
548   done
549   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
550   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
551   # mencoder default DVD audio track language selection (english)
552   lang_opts="-aid $aid -alang en"
553 }
554
555 function check_vob_for_corrupted_start {
556   # check to see if the beginning of the DVD has a form of copy protection
557   # where they have deliberately broken the first X number of frames of the DVD.
558   # If we don't skip these, our resulting VOB file will not play.
559   badvobcheck=`tempfile`
560   endpos=360
561   skip=0
562   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
563   if [ $? != 0 ]; then
564     fatal_and_exit "-E- Mencoder Failed"
565   fi
566   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
567   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
568     (( skip = skip + 5 ))
569     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
570     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
571     if [ $? != 0 ]; then
572       fatal_and_exit "-E- Mencoder Failed"
573     fi
574     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
575   done
576   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
577
578   # cat the giant VOB into mencoder to create a playable VOB file
579   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
580   if [ $? != 0 ]; then
581     fatal_and_exit "-E- Mencoder Failed"
582   fi
583 }
584
585 function check_vob_for_completeness {
586   # check to make sure we got out a complete VOB.
587   # there is another kind of copy protection where the VOB's may
588   # have "MPG EOF" frames in the middle of the stream. 
589   # this causes mencoder to not process the entire VOB, and exit without any errors.
590   # detect this by seeing how much smaller the dst vob is from the src vob.
591   MAX_FILESIZE_DELTA_PERCENT=70
592   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
593   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
594   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
595   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
596     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
597     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
598     create_main_vob_with_mplayer "$isofile"
599     [[ -e "$dumplog" ]] && rm -f $dumplog
600     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
601     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
602     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
603       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
604     fi
605   fi
606 }
607
608 function check_vob_for_too_many_video_packets {
609   # If our earlier algorithm to work around this failed, throw an error.
610   # check to see if this DVD has a protection scheme we don't know how to work around
611   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
612   # for some reason, the video is black, while the audio rolls, then the video finally comes
613   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
614   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
615   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
616   grep -q "Too many video packets in the buffer:" "$logfile"
617   if [ $? == 0 ]; then
618     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
619     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
620     create_main_vob_with_mplayer "$isofile"
621     grep -q "Too many video packets in the buffer:" $dumplog
622     if [ $? == 0 ]; then
623       [[ -e "$dumplog" ]] && rm -f $dumplog
624       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
625     fi
626     [[ -e "$dumplog" ]] && rm -f $dumplog
627   fi
628 }
629
630 function check_vob_for_a52_crc_errors {
631   # Let's see if we can playback our newly created VOB file without any errors.
632   # if there are issues, let's detect them now, and try to recreate the VOB
633   # there are some forms of copy protection that have missed above, that evidence
634   # themselves when we try to playback the VOB file. This was added to deal with
635   # the "a52: CRC check failed" copy protection scheme.
636   MAX_ERRORS=10
637   ENDPOS=120
638   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
639   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
640   cat $dumplog | grep -v "^A:" >> "$logfile"
641   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
642   if [ $errors -gt $MAX_ERRORS ]; then
643     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
644     create_main_vob_with_mplayer "$isofile"
645     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
646     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
647     if [ $? != 0 ]; then
648       cat $dumplog | grep -v "^A:" >> "$logfile"
649       fatal_and_exit "-E- Mplayer Failed"
650     fi
651     cat $dumplog | grep -v "^A:" >> "$logfile"
652     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
653     if [ $errors -gt $MAX_ERRORS ]; then
654       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
655     fi
656   fi
657   [[ -e "$dumplog" ]] && rm -f $dumplog
658 }
659
660 function calculate_bitrate_from_target_size {
661   # determine what our bitrate needs to be if a target size was specified instead
662   if [ $target_size -ne 0 ]; then
663     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
664     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
665     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
666   fi
667 }
668
669 function create_dvdauthor_dvd_xml_file {
670   # make a dvdauthor xml menu file to create a valid DVD video from 
671   # this script does a good job, but we'll still need to clean it up a bit after it runs
672   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
673   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
674   if [ $? != 0 ]; then
675     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
676   fi
677
678   # replace the first line of the xml file to remove the bad dest path
679   awk -v line=1 -v new_content="<dvdauthor>" '{
680     if (NR == line) {
681       print new_content;
682     } else {
683       print $0;
684     }
685   }' dvd.xml > dvd.xml.new
686   mv -f dvd.xml.new dvd.xml
687   if [ $? != 0 ]; then
688     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
689   fi
690
691   # remove the "<video " property line from the xml file
692   cat dvd.xml | grep -v "<video" > dvd.xml.new
693   mv -f dvd.xml.new dvd.xml
694   if [ $? != 0 ]; then
695     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
696   fi
697   
698   # remove the extra <pgc>..</pgc> pairs
699   cat dvd.xml | awk 'BEGIN {x=1}
700   {
701     if ($0~"</pgc>") {x=0}
702     if (x==1) {print $0}
703     if ($0~"<pgc>") {x=1}
704   }' > dvd.xml.new
705   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
706   mv -f dvd.xml.new dvd.xml
707   if [ $? != 0 ]; then
708     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
709   fi
710
711   # remove the VTS_*_0.VOB file as this is just the main menu video clip
712   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
713   mv -f dvd.xml.new dvd.xml
714   if [ $? != 0 ]; then
715     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
716   fi
717 }
718
719 function check_for_mplayer_dumpstream_incompatibility {
720
721   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
722
723   if [ ! -e "$vobfile" ]; then
724     # mplayer dumpstream does not work on DVDs that obscure the feature title.
725     # A DVD that has 99 titles, where the longest title isn't the main feature
726     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
727     # out what the feature title is. This script will run through that flow if we
728     # set use_mplayer_dumpstream to 0. Check for this here.
729     if [ $ripdvd -eq 1 ]; then
730       lsdvd $dev | grep -q "Title: 99"
731     else
732       lsdvd "$isofile" | grep -q "Title: 99"
733     fi
734     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
735     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
736       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
737         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
738         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
739         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
740         invalid_feature_title=1
741       else 
742         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
743         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
744         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
745         use_mplayer_dumpstream=0
746         invalid_feature_title=1
747       fi
748       return
749     fi
750   fi
751
752   # There is another form of protection that causes the mplayer dumpstream to fail. 
753   # This can be detected by telling mplayer to parse the VOB file by copying its audio
754   # video streams to a dummy output file (/dev/null). Do that here to check for that 
755   # problem before continuing.
756   if [ -e "$vobfile" ]; then
757     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
758     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
759     grep -q "Too many audio packets in the buffer" $dumplog
760     if [ $? == 0 ]; then
761       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
762       use_mplayer_dumpstream=0
763       mplayer_dumpstream_incompatibility=1
764     fi
765     [[ -e "$dumplog" ]] && rm -f $dumplog
766   fi
767 }
768
769 function fill_mythvideo_metadata {
770
771   # This function must be passed the filename as an argument
772   # The filename must be a full path to the file
773   filename="$1"
774
775   # Make sure the fill mythvideo metadata option has been set to 1
776   if [ $fill_mythvideo_metadata -eq 0 ]; then
777     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
778     return 0
779   fi
780
781   # If the fill mythvideo metadata script is present, run it
782   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
783   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
784     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
785     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
786   else
787     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
788     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
789   fi
790 }
791
792 # remove the intermediate VOB file
793 function remove_intermediate_vob_file {
794   if [ $keep_intermediate_files -eq 0 ]; then
795     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
796   else
797     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
798   fi
799 }
800
801 # remove the original DVD image 
802 function remove_intermediate_iso_file {
803   [[ $keep_isofile -eq 1 ]] && return 1
804   if [ $keep_intermediate_files -eq 0 ]; then
805     [[ -e "$isofile" ]] && rm "$isofile"
806   else
807     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
808   fi
809 }
810
811 # remove the intermediate dvdbackup folder
812 function remove_intermediate_dvdbackup_folder {
813   if [ $keep_intermediate_files -eq 0 ]; then
814     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
815   else
816     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
817   fi
818 }
819
820 ###############################################
821 # MAIN
822
823 # Make a note of when this DVD rip started
824 date=`date`
825 echo -e "\n$date DVD rip started" >> "$logfile"
826
827 # Rip the DVD - Mirror Mode
828 if [ $mirror_mode -eq 1 ]; then
829   echo "-> Ripping DVD $dvdname to $dest"
830
831   # use ddrescue to make an ISO image of the disk
832   make_dvd_iso_image "$dest/$dvdname.iso"
833
834   # add this video data to the mythtv DB
835   fill_mythvideo_metadata "$dest/$dvdname.iso" 
836
837   # eject the disk upon completion
838   eject -T $dev
839
840   date=`date`
841   echo "$date DVD rip completed" | tee -a "$logfile"
842
843   if [[ -n "$mailto" ]]; then
844     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
845   fi
846
847 fi
848
849 # Rip the DVD - Main Title Feature Only
850 if [ $mirror_mode -eq 0 ]; then
851
852   # Rip image from DVD
853   if [ $ripdvd -eq 1 ]; then
854     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
855     # use ddrescue to make an ISO image of the disk
856     make_dvd_iso_image "$tmpdir/$dvdname.iso"
857   fi
858
859   # Rip image from DVD path
860   if [ -n "$dvdpath" ]; then
861     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
862     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
863   fi
864
865   # make sure our isofile value is set
866   if [ -z "$isofile" ]; then
867     isofile="$tmpdir/$dvdname.iso"
868   fi
869      
870   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
871
872     if [ ! -e "$vobfile" ]; then
873       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
874       
875       # get the feature title from the ISO
876       get_feature_title "$isofile"
877  
878       # get the crop value from the ISO
879       get_crop_from_iso
880
881       # check for mplayer dumpstream incompatibilities
882       # if they exist, this method will set this mode to 0.
883       check_for_mplayer_dumpstream_incompatibility
884
885       if [ $use_mplayer_dumpstream -eq 1 ]; then 
886
887         # get our audio id from the ISO file
888         get_audio_id_from_iso "$isofile"
889
890         # create our main VOB file from the ISO
891         create_main_vob_with_mplayer "$isofile"
892      
893         # remove the intermediate VOB file
894         remove_intermediate_vob_file
895
896         # it's possible that our VOB is still corrupted in some manner
897         # check to make sure it is still a good VOB before continuing.
898         check_for_mplayer_dumpstream_incompatibility
899
900       fi
901  
902       if [ $use_mplayer_dumpstream -eq 0 ]; then 
903
904         # use dvdbackup to make a DVD folder of the feature title
905         make_dvdbackup_folder_image
906   
907         # create our main VOB file
908         create_main_vob_with_cat
909
910         # get our audio id from the VOB file
911         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
912   
913         # check for corrupted VOB start
914         check_vob_for_corrupted_start
915  
916         # check to make sure our VOB is complete
917         check_vob_for_completeness
918
919         # check to make sure our VOB doesn't have too many video packets
920         check_vob_for_too_many_video_packets
921
922         # check to make sure our VOB doesn't have a52 crc errors
923         check_vob_for_a52_crc_errors
924
925         # remove the intermediate VOB file
926         remove_intermediate_vob_file
927
928       fi
929
930       # remove the intermediate ISO file
931       remove_intermediate_iso_file
932
933     else
934       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
935     fi
936
937     # transcode the DVD
938     if [ $make_final_dest_avi -eq 1 ]; then
939       echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
940
941       # determine what our bitrate needs to be if a target size was specified instead
942       calculate_bitrate_from_target_size        
943       
944       # There was a lot of experimentation to arrive at these values
945       # These seem to work OK for me. If they don't work for you, feel
946       # free to adjust/change as needed.
947
948       # Edit these as needed to suite your needs
949       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
950       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
951       mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
952       mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=$mencoder_threads"
953
954       # There are a number of different ways to encode 6 channel audio.
955       # I've loaded 3 different ways into the mencoder_audioch_opts.
956       # It will cycle through them until it finds one that works. 
957       # You can change the order to suit your needs.
958       if [ $audio_2ch -eq 0 ]; then
959
960         # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
961         #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
962         #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
963
964         # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
965         # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
966         mencoder_audio_opts="-oac copy"
967
968         # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
969         mencoder_audioch_opts[0]="-channels 6 -af channels=6"
970         mencoder_audioch_opts[1]="-af channels=6"
971         mencoder_audioch_opts[2]=""
972
973      else 
974         # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
975         mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
976         mencoder_audioch_opts[0]=""
977      fi
978
979       # Do not edit this line. $mencoder_video_encoder_opts must be last
980       mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
981       mencoder_retval=0
982
983       for PASS in 1 2 
984       do 
985         # Set some options based on which pass we are in
986         mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
987         [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
988         [ $PASS -eq 1 ] && output_file="/dev/null"
989         [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
990   
991         # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
992         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
993         do
994           echo -e "   Encoding pass $PASS"
995           echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
996           mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
997           mencoder_retval=$? 
998           grep -q "\[channels\] Invalid" $encodelog
999           if [ $? != 0 ]; then      
1000             break;
1001           else
1002             echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
1003           fi
1004         done
1005         if [ $mencoder_retval != 0 ]; then
1006           fatal_and_exit "-E- Unhandled mencoder error"
1007         fi
1008         # Concatenate the encode log to our main log file, greping out unwanted lines
1009         cat $encodelog | grep -v "Pos:" >> "$logfile"
1010       done
1011
1012       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1013         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1014         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1015       else
1016         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1017         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1018       fi
1019     fi
1020
1021   # add this video data to the mythtv DB
1022   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
1023   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1024     
1025   else
1026
1027   # use dvdbackup to make a DVD folder of the feature title
1028   make_dvdbackup_folder_image
1029
1030   # cd to the feature title DVD folder
1031   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1032   if [ $? != 0 ]; then
1033     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1034   fi
1035   
1036   # create the dvd.xml file for dvdauthor
1037   create_dvdauthor_dvd_xml_file  
1038
1039   # make the final DVD folder image
1040   make_dvdauthor_folder_image
1041
1042   # add this video data to the mythtv DB
1043   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1044  
1045   # cd back to the dir we started from
1046   popd > /dev/null 2>&1
1047
1048   if [ $make_final_dest_iso -eq 1 ]; then
1049
1050     # make an iso image out of our directory
1051     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1052    
1053     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1054     if [ -s "$dest/$dvdname.iso" ]; then
1055       if [ $make_final_dest_folder -eq 0 ]; then
1056         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1057         # remove the folder of the DVD image now that we have a .iso version of it
1058         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1059       fi
1060     else
1061       # we created an empty iso file, remove it
1062       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1063       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1064       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1065     fi
1066  
1067     # add this video data to the mythtv DB
1068     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1069
1070   fi
1071
1072   fi
1073
1074   # remove the ddrescue DVD ISO image
1075   remove_intermediate_iso_file
1076
1077   # remove the tmp dvdbackup folder of the DVD image
1078   remove_intermediate_dvdbackup_folder
1079
1080   # eject the DVD disk upon completion
1081   [ $ripdvd -eq 1 ] && eject -T $dev
1082
1083   date=`date`
1084   echo "$date DVD rip completed" | tee -a "$logfile"
1085
1086   if [[ -n "$mailto" ]]; then
1087     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1088   fi
1089
1090 fi
1091